10 filename$ = home_dir$ & 'FI2Call_bas'
12 :
14 xt% = 2
16 dim actx$(xt%, 6)
18 actx$(0) = 'Test1'
20 actx$(1) = 'Test2'
22 actx$(2) = 'Test3'
24 :
26 action% = FI2Call(filename$, actx$)
28 act%    = FI2acts(filename$, xt%, action%)
30 :
32 print 'Action no.:'! act%
34 sel on act%
36  = -29 to -1: print 'Error'! act%
38  = 0: print 'Test 1'
40  = 1: print 'Test 2'
42  = 2: print 'Test 3'
44  = remainder
46    print 'Act:'!fi_act$\'Thing:'!fi_thg$\'File:'!fi_fnm$\'CMD:'!fi_cmd$\'Mand:'!fi_mfn$\'Flag:'!fi_flg$
48 endsel
50 pause
52 quit
54 :
56 :
100 rem + ************************************************************************ +
102 rem *<                        FileInfo2 Extra Actions                         >*
104 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
106 rem * This suit of routines allows for the building of non-standard FI2 action *
108 rem * menus.                                                                   *
110 rem *                                                                          *
112 rem * You can add aditional items in front of the menu (or with                *
114 rem * modification, to the end - or simply provide your own menu design.)      *
116 rem *                                                                          *
118 rem * Note that not all available FI2 actions are shown; it depends on the     *
120 rem * calling job. One could use FI2_SCAN%/FI2_SCAN$ instead if every          *
122 rem * possible action was wanted.                                              *
124 rem + ------------------------------------------------------------------------ +
126 rem * V0.01, pjw, 2021 Dec 15                                                  *
128 rem + ************************************************************************ +
130 :
132 :
134 def fn FI2Call(fnm$, xtra$)
136 loc i%, noa%, xtra%, wid%
138 noa% = ftest(fnm$): if noa% < 0: ret noa%
140 noa% = fi2_actn%(fnm$)
142 if noa% < 0: ret noa%
144 :
146 wid% = dimn(xtra$(0))
148 xtra% = dimn(xtra$)
150 :
152 for i% = 1 to noa%
154  l$ = fi2_parm$(5, fnm$, i%)
156  if len(l$) > wid%: wid% = len(l$)
158 endfor i%
160 ret FI2menu(noa%, xtra%, wid%, xtra$)
162 enddef FI2Call
164 :
166 :
168 def fn FI2menu(n%, x%, w%, x$)
170 loc i%, acts$(n% + x%, w%)
172 :
174 for i% = 0 to x%: acts$(i%) = x$(i%)
176 for i% = x% + 1 to n% + x%
178  acts$(i%) = fi2_parm$(5, fnm$, i% - x%)
180 endfor i%
182 ret list_select('Action', acts$)
184 enddef FI2menu
186 :
188 :
190 def fn FI2acts(fnm$, xtra%, act%)
192 loc a%
194 sel on act%
196  = -29 to -1: ret act%: rem ESC, OK or error
198  = 0 to xtra%: ret act%
200 endsel
202 a% = act% - xtra%
204 :
206 fi_thg$ = fi2_parm$(0, fnm$, a%):       rem Thing name
208 fi_fnm$ = fi2_parm$(1, fnm$, a%):       rem File name
210 fi_cmd$ = fi2_parm$(3, fnm$, a%):       rem Command line
212 fi_mfn$ = fi2_parm$(4, fnm$, a%):       rem Mandatory/forbidden
214 fi_act$ = fi2_parm$(5, fnm$, a%):       rem Action name
216 fi_flg$ = fi2_parm$(6, fnm$, a%):       rem Flags
218 ret act%
220 enddef FI2acts
222 :
224 :
